



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>使用RequireJS并实现一个自己的模块加载器  (一)</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">使用RequireJS并实现一个自己的模块加载器  (一)</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-26 11:21:46 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h2>RequireJS &amp; SeaJS</h2>
<p>在 <code>模块化开发</code> 开发以前，都是直接在页面上引入 <code>script</code> 标签来引用脚本的，当项目变得比较复杂，就会带来很多问题。</p>
<ul><li>JS项目中的依赖只有通过引入JS的顺序来确定，项目会变得复杂难以维护。</li>
<li>复杂的脚本会暴露很多全局变量， 比如 $,_. ... 。</li>
<li>同步加载的时候，网页会停止渲染，加载时间越长，网页失去响应的事件就越长。</li></ul>
<p>于是，AMD 规范就诞生了，AMD 即为异步模块定义，有效避免同步加载导致页面的假死现象。RequireJS 是一个 AMD 的实现，后来还有CMD规范，玉伯的 而SeaJS 是 CMD 的一个实现，两者最大的区别就是</p>
<blockquote><p>RequireJS 是预加载，而sea.js 是懒加载，也就是按需加载</p></blockquote>
<p>什么意思 ？？</p>
<p>比如下面的代码</p>
<pre class="prettyprint linenums"><code>define(function(require,exports,module){<br />
    // do something<br />
    var mod1 = require('./mod1');<br />
    // do something<br />
    var mod2 = require('./mod2');<br />
})

</code></pre>
<p>RequireJS 会全部找到这个模块的依赖，并在开始执行是就加载全部的依赖，<br /><br />
而SeaJS 则是按需加载，直到遇到 require 才会加载。</p>
<blockquote><p>RequireJS 内部通过 <code>Function.prototype.toString()</code> ，然后使用正则匹配所有的require 方法，将其转化为</p></blockquote>
<pre class="prettyprint linenums"><code>define(['./mod1',./mod2']function(mod1,mod2)<br />
</code></pre>
<p>这种方式。</p>
<p>有很多关于这两种方式的争吵，由于我没有做过较大的项目，所以对于这两种方式在正真项目中使用的区别也不清楚。</p>
<h2>回顾 RequireJS</h2>
<p>主要接口有两个： <code>require</code> &amp; <code>define</code>,define 是模块的定义方法，require 是模块的使用方法。<br /><br />
define 的参数为 <code>define (id?,deps?,factory)</code>。第一个为模块ID，第2个为依赖列表，第三个是工厂方法 。如果不定义ID，则为匿名方法，通常情况，模块ID 等于模块在工程的路径。deps 和 factory 有约定，deps 数组有多少个元素，factory 就会有多少个形参，形参对于与依赖模块工厂函数执行后的返回值。</p>
<pre class="prettyprint linenums"><code>define (&quot;id&quot;,[&quot;mod1&quot;,&quot;mod2&quot;],function(mod1,mod2){<br />
    return {<br />
        ///<br />
    };<br />
})<br />
</code></pre>
<p>require 方法和 define 基本一致。</p>
<p>文件目录</p>
<pre class="prettyprint linenums"><code>└─ use-require/<br />
   ├─ app/<br />
   │  ├─ js/<br />
   │  │  ├─ module/<br />
   │  │  │  ├─ a.js<br />
   │  │  │  └─ b.js<br />
   │  │  ├─ main.js<br />
   │  └─ lib/<br />
   │  │  └─ require.js<br />
   ├─ index.html<br />
   └─ readme.md<br />
</code></pre>
<p>现在,需要在 index.html 引导整个程序 。</p>
<pre class="prettyprint linenums"><code>&lt;!DOCTYPE html&gt;<br />
&lt;html lang=&quot;en&quot;&gt;<br />
&lt;head&gt;<br />
    &lt;meta charset=&quot;UTF-8&quot;&gt;<br />
    &lt;title&gt;Document&lt;/title&gt;<br />
&lt;/head&gt;

&lt;body&gt;<br />
     &lt;script src=&quot;./app/lib/require.js&quot; data-main=&quot;./app/js/main&quot;&gt;<br />
    &lt;/script&gt;<br />
&lt;/body&gt;<br />
&lt;/html&gt;

</code></pre>
<p>引入 requirejs，并通过 <code>data-main</code> 申明 启动 js 文件。</p>
<blockquote><p>注意：  data-main 指向的文件所在路径就是 baseUrl，在这里就是app/js ,<br /><br />
baseUrl 也可以通过require.config 设置 。如果没有通过 data-main 属性指定 baseUrl ，也没有通过config的方式显示声明 baseUrl ，那么 baseUrl 默认为加载requirejs的那个页面所在的路径<br /><br />
下面 b  依赖 a ，那么就应该写 <code>module/a</code>,而 main 依赖 b ，写为 <code>module/b</code> ，这个路径会和 baseUrl 拼接，与a ，b 所在的路径无关 。有时候，你可能需要生成一个相对于模块的URL地址。你可以将<code>require</code>作为一个依赖注入进来，然后调用<code>require.toUrl()</code>以生成该URL 。</p>
<pre class="prettyprint linenums"><code>define([&quot;require&quot;], function(require) {<br />
</code></pre></blockquote>
<pre class="prettyprint linenums"><code>var url = require.toUrl(&quot;./style.js&quot;);<br />
</code></pre>
<p>});</p>
<blockquote><pre class="prettyprint linenums"><code></code></pre></blockquote>
<p>有时候你想避开&quot;baseUrl + paths&quot;的解析过程，而是直接指定加载某一个目录下的脚本。此时可以这样做：如果一个module ID符合下述规则之一，其ID解析会避开常规的&quot;baseUrl + paths&quot;配置，而是直接将其加载为一个相对于当前HTML文档的脚本：<br /><br />
注意是 相对于 HTML 文档，因为 js脚本是会被插入到 html 文档中执行的 。</p>
<ul><li>以 &quot;.js&quot; 结束 。</li>
<li>以 &quot;/&quot; 开始。</li>
<li>包含 URL 协议, 如 &quot;http:&quot; or &quot;https:&quot;。</li></ul>
<p>一般来说，最好还是使用baseUrl及&quot;paths&quot; config去设置module ID。它会给你带来额外的灵活性，如便于脚本的重命名、重定位等。 同时，为了避免凌乱的配置，最好不要使用多级嵌套的目录层次来组织代码，而是要么将所有的脚本都放置到baseUrl中，要么分置为项目库/第三方库的一个扁平结构，如下：</p>
<pre class="prettyprint linenums"><code>└─ project/<br />
   ├─ js/<br />
   │  ├─ app/<br />
   │  │  └─ sub.js<br />
   │  ├─ lib/<br />
   │  │  ├─ jquery.js<br />
   │  │  └─ require.js<br />
   │  └─ app.js<br />
   ├─ index.html<br />
   └─ readme.md 

</code></pre>
<p>下面自然就顺利成章<br /><br />
申明模块a</p>
<pre class="prettyprint linenums"><code>define(function() {<br />
    'use strict';<br />
    return {<br />
        name: &quot;hello , i am a&quot;<br />
    }<br />
})

</code></pre>
<p>模块 b</p>
<pre class="prettyprint linenums"><code>define([&quot;module/a&quot;], function(a) {<br />
  'use strict';<br />
    var aName = a.name;<br />
    var name = &quot;hello i am b&quot;;<br />
    return {<br />
        sayHello: function() {<br />
            console.log(name + &quot;  my brother is &quot; + aName);<br />
        }<br />
    }<br />
})<br />
</code></pre>
<blockquote><p>在模块b 里面依赖模块a 。</p></blockquote>
<p>main.js</p>
<pre class="prettyprint linenums"><code>require([&quot;module/b&quot;], function(b) {<br />
  'use strict';<br />
    b.sayHello();<br />
})<br />
</code></pre>
<p>看看效果<br /><br />
<img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/857465/201612/857465-20161231021247820-808097576.png"></p>
<p>如果使用 <code>require.config()</code> 配置呢？<br /><br />
将上面的目录复制一份，命名 <code>use-require-config</code>，目录结构完全一致</p>
<p>main.js</p>
<pre class="prettyprint linenums"><code>requirejs.config({<br />
    baseUrl: './app/js/module'<br />
})

require([&quot;.b&quot;], function(b) {<br />
    'use strict';<br />
    b.sayHello();<br />
})

</code></pre>
<blockquote><p>在这里，将配置放在 main.js 里面,等会儿会讲如果不放在它里面会又什么问题。</p></blockquote>
<p>模块 b 依赖 于 a</p>
<pre class="prettyprint linenums"><code>define([&quot;./a&quot;], function(a) {<br />
    'use strict';<br />
    var aName = a.name;<br />
    var name = &quot;hello i am b&quot;;<br />
    return {<br />
        sayHello: function() {<br />
            console.log(name + &quot;  my brother is &quot; + aName);<br />
        }<br />
    }<br />
})

</code></pre>
<blockquote><p>由于将<code>baseUrl</code> 设置为 <code>app/js/module</code>  ，所以这里依赖<code>a</code> 就可以直接写<code>a</code><br /><br />
在这里，我使用 <code>./a</code>, 与直接写 <code>a</code> 一模一样，还是使用 <code>baseUrl+ moduleName</code> `来寻找模块路径。<br /><br />
<img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/857465/201612/857465-20161231021309789-1638903481.png"></p></blockquote>
<p>如果不将  <code>requirejs.config</code> 放在main中，而是另外在引入一个script 节点来放置 呢</p>
<pre class="prettyprint linenums"><code>&lt;body&gt;<br />
    &lt;script src=&quot;./app/lib/require.js&quot; data-main=&quot;./app/js/main&quot;&gt;<br />
    &lt;/script&gt;<br />
    &lt;script&gt;<br />
        requirejs.config({<br />
           baseUrl: './app/js/module'<br />
        })<br />
    &lt;/script&gt;<br />
&lt;/body&gt;<br />
</code></pre>
<p>在浏览器运行<br /><br />
<img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/857465/201612/857465-20161231021317007-104980649.png"></p>
<p>发现报错了，怎么回事呢？<br /><br />
看它寻找 main.js 的路径</p>
<pre class="prettyprint linenums"><code>file:///E:/HFLib/module/code/use-require-config/app/js/module/main.js<br />
</code></pre>
<p>是 baseUrl + main.js。 这说明，配置的 baseUrl 覆盖了为 data-main 配置的路径<br /><br />
也就是说，一旦使用requirejs.config 来配置 baseUrl，那么所有的路径都会以  baseUrl 为基准。<br /><br />
所以，data-main 应改为: <code>..\main</code>,注意这里必须要使用反斜杠，正斜杠拼接总是会出现问题。<br /><br />
通过这样就可以解决 data-main 和 requirejs.config() 的冲突了 。</p>
<p>paths 和 shim 。</p>
<p>当模块名过长是，require.js 为我们提供了路径 paths 的方式 。<br /><br />
理想状况下，每个加载的脚本都是通过define()来定义的一个模块；但有些&quot;浏览器全局变量注入&quot;型的传统/遗留库并没有使用define()来定义它们的依赖关系，你必须为此使用shim config来指明它们的依赖关系。</p>
<p>这是我的文件目录<br /><br />
<img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/857465/201612/857465-20161231021330382-734887124.png"></p>
<p>index.html</p>
<pre class="prettyprint linenums"><code>&lt;body&gt;<br />
    &lt;script src=&quot;./app/lib/require.js&quot; data-main=&quot;./app/main&quot;&gt;<br />
    &lt;/script&gt;<br />
&lt;/body&gt;

</code></pre>
<p>main.js</p>
<pre class="prettyprint linenums"><code>requirejs.config({<br />
    paths: {<br />
        jQuery: 'lib/jQuery'<br />
    },<br />
    shim: {<br />
        'jQuery': {<br />
            exports: '$'<br />
        }<br />
    }<br />
})

require(['jQuery'], function($) {<br />
    'use strict';<br />
    console.log($);<br />
})

</code></pre>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/857465/201612/857465-20161231021339961-2016320415.png"></p>
<p>可以看到，已经顺利注入了 jQuery 依赖。</p>
<p>require.js 中还有很多配置和用法，我用的就比较少，就简单介绍到这里。<br /><br />
下来，我要实现一个简化的模块加载器，类似于 require.js.</p>
<h2>实现一个自己的模块加载器</h2>
<p>太晚了 。</p>
<p>就在 实现一个自己的模块加载器（二）中实现一个类似 require.js 的Demo 吧 。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/39r5ldq0.html">掌握javascript中的最基础数据结构-----数组</a>
		</li>
						<li><a href="https://www.batexi.com/a/m8z1gz19.html">co源码解读</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqvvy2jq.html">CSS-垂直&vert;水平居中问题的解决方法总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/390d0638.html">ajax传递array参数</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qy5rnm9.html">旷世奇坑！！！spring 不能自动注入</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqv7wnjq.html">如何用javac 和java 编译运行整个Java工程 &lpar;转载&rpar;【转】在Linux下编译与执行Java程序</a>
		</li>
						<li><a href="https://www.batexi.com/a/2q7pn2gq.html">navicat&amp;&num;160&semi;for&amp;&num;160&semi;mysql&amp;&num;160&semi;10&period;1&period;7注册码</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxnw2yv8.html">ViewPager相互嵌套，导致子ViewPager无法滑动，且子ViewPager中的view无法被点击</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxn2p6e8.html">使用Log Explorer查看和恢复数据</a>
		</li>
						<li><a href="https://www.batexi.com/a/93x3l3g9.html">aws linuxbrew GLIBC&lowbar;PRIVATE not defined in file ld-linux-x86-64&period;so&period;2</a>
		</li>
						<li><a href="https://www.batexi.com/a/95xy6wz8.html">TCP&sol;IP协议原理与应用笔记15：网络连接设备</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mejvepq.html">IE8下 Select文字垂直居中的办法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv1ex61q.html">JVM基础&lpar;6&rpar;-常用参数总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/93yllpn8.html">eclipse和android studio的目录结构分析</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy1k5zgq.html">基于令牌桶算法实现的SpringBoot分布式无锁限流插件</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kjm6p69.html">linux-shell系列5-统计</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7olrx18.html">react实现极简搜索框效果</a>
		</li>
						<li><a href="https://www.batexi.com/a/90redpn9.html">spring3&period;0&plus;Atomikos 构建jta的分布式事务</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o1xk0eq.html">关于oracle RAC心跳线采用直连 还是交换机连接的建议</a>
		</li>
						<li><a href="https://www.batexi.com/a/qx2on4d8.html">Oracle数据库返回字符类型-1~1的结果处理</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/p39r0r90.html">【原】谈谈对Objective-C中代理模式的误解</a>
			</li>
						<li><a href="https://www.batexi.com/a/rqljoe9o.html">webpack的使用</a>
			</li>
						<li><a href="https://www.batexi.com/a/r93w6rq3.html">CSS垂直居中的11种实现方式</a>
			</li>
						<li><a href="https://www.batexi.com/a/495py6qz.html">【微信小程序开发】之如何获取免费ssl证书【图文步骤】</a>
			</li>
						<li><a href="https://www.batexi.com/a/g8eo4jq1.html">Git使用详细教程（二）</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8k5vj8j.html">java中的移位运算符：&amp;lt&semi;&amp;lt&semi;&comma;&amp;gt&semi;&amp;gt&semi;&comma;&amp;gt&semi;&amp;gt&semi;&amp;gt&semi;总结</a>
			</li>
						<li><a href="https://www.batexi.com/a/g8ej5j91.html">如何给FineReport设置自定义消息提醒工具</a>
			</li>
						<li><a href="https://www.batexi.com/a/39r1km80.html">BZOJ 3894&colon; 文理分科 &lbrack;最小割&rsqb;</a>
			</li>
						<li><a href="https://www.batexi.com/a/4qny3g8r.html">瞬间记住Javascript中apply与call的区别</a>
			</li>
						<li><a href="https://www.batexi.com/a/m96dgv84.html">&period;NET跨平台：在Ubuntu上用自己编译的dnx运行ASP&period;NET 5示例程序</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
